plugin.tx_caddy_pi1 {
    // empty statement for proper comments only
  api {
  }
    // marker
  api =
  api {
      // item, sum
    marker =
    marker {
        // delete, gross, min, max, uid, qty, service attributes (1-3), sku, stockmanagement, stockquantity, title, tax
      item =
      item {
          // delete icon: for removing the current item from the caddy
        delete = IMAGE
        delete {
          file = {$plugin.caddy.html.color.icon.delete}
          altText.data = LLL:EXT:caddy/pi1/locallang.xml:delete
          titleText.data = LLL:EXT:caddy/pi1/locallang.xml:delete
          params = class="caddy_delete"
          imageLinkWrap = 1
          imageLinkWrap {
            enable = 1
            typolink {
              parameter {
                cObject = COA
                cObject {
                    // URL
                  10 = TEXT
                  10 {
                    data = page:alias//TSFE:id
                  }
                    // target
                  20 = TEXT
                  20 {
                    value       = -
                    noTrimWrap  = | ||
                  }
                    // class
                  30 = TEXT
                  30 {
                    value       = onClickloadCaddyByAjax
                    noTrimWrap  = | ||
                  }
                }
              }
              additionalParams {
                wrap  = &tx_caddy_pi1[del]=|
                field = uid
              }
            }
          }
        }
        delete >
          // delete icon: for removing the current item from the caddy (#i0084)
        delete = TEXT
        delete {
          value = &times;
          //value = <i class="fi-trash"></i>
            // parameter, additionalParams
          typolink =
          typolink {
              // cObject
            parameter =
            parameter {
              cObject = COA
              cObject {
                  // URL
                10 = TEXT
                10 {
                  data = page:alias//TSFE:id
                }
                  // target
                20 = TEXT
                20 {
                  value       = -
                  noTrimWrap  = | ||
                }
                  // class
                30 = TEXT
                30 {
                  //value       = button delete mytiny alert onClickloadCaddyByAjax
                  value       = btn btn-primary button delete mytiny onClickloadCaddyByAjax
                  noTrimWrap  = | "|"|
                }
                  // title
                40 = TEXT
                40 {
                  data = LLL:EXT:caddy/pi1/locallang.xml:delete
                  noTrimWrap  = | "|"|
                }
              }
            }
              // field, wrap
            additionalParams =
            additionalParams {
              field = uid
              wrap  = &tx_caddy_pi1[del]=|
            }
          }
        }
          // gross, grossvariants
        gross = COA 
        gross {
            // gross costs of the item
          10 = 
          10 < plugin.tx_caddy.defaults.numberFormatCurrency
          10 {
            field = gross
            value >
          }
            // grossvariants costs of the item
          20 = 
          20 < plugin.tx_caddy.defaults.numberFormatCurrency
          20 {
              // if isTrue field grossvariants
            if =
            if {
              isTrue {
                field = grossvariants
              }
            }
            field = grossvariants
            value >
            noTrimWrap = |<br />+||
          }
        }
          // minimum quantity for ordering
        min = TEXT
        min {
          field = min
        }
          // maximum quantity for ordering
        max = TEXT
        max {
          field = max
        }
          // net costs of the item
        net =
        net < plugin.tx_caddy.defaults.numberFormatCurrency
        net {
          field = net
          value >
        }
          // quantity of the item
        qty = TEXT
        qty {
          field = qty
        }
          // service attribute 1
        service_attribute_1 = TEXT
        service_attribute_1 {
          field = service_attribute_1
        }
          // service attribute 2
        service_attribute_2 = TEXT
        service_attribute_2 {
          field = service_attribute_2
        }
          // service attribute 3
        service_attribute_3 = TEXT
        service_attribute_3 {
          field = service_attribute_3
        }
          // stock keeping unit
        sku = TEXT
        sku {
          field = sku
        }
          // [Boolean] stockmanagement
        stockmanagement = TEXT
        stockmanagement {
          field = stockmanagement
        }
          // [Integer] stock keeping unit
        stockquantity = TEXT
        stockquantity {
          field = stockquantity
        }
          // gross costs sum ( gross costs * quantity )
        sumgross =
        sumgross < plugin.tx_caddy.defaults.numberFormatCurrency
        sumgross {
          field = sumgross
          value >
        }
          // net costs sum ( net costs * quantity )
        sumnet =
        sumnet < plugin.tx_caddy.defaults.numberFormatCurrency
        sumnet {
          field = sumnet
          value >
        }
          // tax costs sum ( tax costs * quantity )
        sumtax =
        sumtax < plugin.tx_caddy.defaults.numberFormatCurrency
        sumtax {
          field = sumtax
          value >
        }
          // tax value of the item (0 , 1, 2)
        // :TODO:? 161031: tax < plugin.tx_caddy.defaults.numberFormatCurrency
        tax = TEXT
        tax {
          field = tax
        }
          // 10: taxrate, 20: {$plugin.caddy.main.percentSymbol}
        taxrate = COA 
        taxrate {
            // taxrate
          10 = TEXT 
          10 {
            current = 1
              // taxrate * 100
            setCurrent =
            setCurrent {
              field = taxrate
              wrap = | * 100
            }
            prioriCalc = 1
          }
            // {$plugin.caddy.main.percentSymbol}
          20 = TEXT 
          20 {
            value = {$plugin.caddy.main.percentSymbol}
          }
        }
          // 10: title, 20: titlevariants
        title = COA
        title {
            // title with typolink
          10 = TEXT
          10 {
            field = title
            typolink {
              additionalParams {
                wrap  = &tx_browser_pi1[{$plugin.caddy.url.showUid}]=|
                field = uid
              }
              forceAbsoluteUrl = 1
              parameter = {$plugin.caddy.pages.shop} - linktosingle
              title {
                value = Item
                lang {
                  de = Artikel
                  en = Item
                }
              }
              useCacheHash = 1
            }
          }
            // titlevariants
          20 = TEXT
          20 {
              // if isTrue field titlevariants
            if =
            if {
              isTrue {
                field = titlevariants
              }
            }
            field = titlevariants
            value >
            noTrimWrap = |<br /><span class="variants" style="font-size:0.75em;">|</span>|
          }
        }
          // uid of the item
        uid = TEXT
        uid {
          field = uid
        }
      }
        // labels, rates, values
      sum =
      sum {
          // payment, shipping, specials
        labels =
        labels {
            // label, gross
          optionspaymentlabel = TEXT
          optionspaymentlabel {
            field = optionspaymentlabel
          }
          optionsshippinglabel = TEXT
          optionsshippinglabel {
            field = optionsshippinglabel
          }
          optionsspecialslabels = TEXT
          optionsspecialslabels {
            field = optionsspecialslabels
          }
            // plus value, VAT
          taxrate_reduced_string = COA
          taxrate_reduced_string {
              // plus value
            10 = TEXT
            10 {
              value = plus
              lang {
                de = zuz&uuml;glich
                en = plus
              }
              noTrimWrap = || {$plugin.caddy.tax.reduced}{$plugin.caddy.main.percentSymbol} |
            }
              // VAT
            20 = TEXT
            20 {
              data = LLL:EXT:caddy/pi1/locallang.xml:tax_abbr
            }
          }
            // plus value, VAT
          taxrate_normal_string = COA
          taxrate_normal_string {
              // plus value
            10 = TEXT
            10 {
              value = plus
              lang {
                de = zuz&uuml;glich
                en = plus
              }
              noTrimWrap = || {$plugin.caddy.tax.normal}{$plugin.caddy.main.percentSymbol} |
            }
              // VAT
            20 = TEXT
            20 {
              data = LLL:EXT:caddy/pi1/locallang.xml:tax_abbr
            }
          }
        }
          // payment, shipping, specials
        rates =
        rates {
          optionspaymentsumrate = 
          optionspaymentsumrate < plugin.tx_caddy.defaults.numberFormatCurrency
          optionspaymentsumrate {
            field = optionspaymentsumrate
            value >
          }
          optionsshippingsumrate < .optionspaymentsumrate
          optionsshippingsumrate.field  = optionsshippingsumrate
          optionsspecialssumrate < .optionspaymentsumrate
          optionsspecialssumrate.field  = optionsspecialssumrate
        }
          // payment, shipping, specials, items, sum, target
        values =
        values {
          optionspaymentsumgross = 
          optionspaymentsumgross < plugin.tx_caddy.defaults.numberFormatCurrency
          optionspaymentsumgross {
            field = optionspaymentsumgross
            value >
          }
          optionspaymentsumnet          < .optionspaymentsumgross
          optionspaymentsumnet.field         = optionspaymentsumnet
          optionspaymentsumtaxnormal    < .optionspaymentsumgross
          optionspaymentsumtaxnormal.field   = optionspaymentsumtaxnormal
          optionspaymentsumtaxreduced   < .optionspaymentsumgross
          optionspaymentsumtaxreduced.field  = optionspaymentsumtaxreduced

          optionsshippingsumgross       < .optionspaymentsumgross
          optionsshippingsumgross.field      = optionsshippingsumgross
          optionsshippingsumnet         < .optionspaymentsumgross
          optionsshippingsumnet.field        = optionsshippingsumnet
          optionsshippingsumtaxnormal   < .optionspaymentsumgross
          optionsshippingsumtaxnormal.field  = optionsshippingsumtaxnormal
          optionsshippingsumtaxreduced  < .optionspaymentsumgross
          optionsshippingsumtaxreduced.field = optionsshippingsumtaxreduced

          optionsspecialssumgross       < .optionspaymentsumgross
          optionsspecialssumgross.field      = optionsspecialssumgross
          optionsspecialssumnet         < .optionspaymentsumgross
          optionsspecialssumnet.field        = optionsspecialssumnet
          optionsspecialssumtaxnormal   < .optionspaymentsumgross
          optionsspecialssumtaxnormal.field  = optionsspecialssumtaxnormal
          optionsspecialssumtaxreduced  < .optionspaymentsumgross
          optionsspecialssumtaxreduced.field = optionsspecialssumtaxreduced

            // Sum gross of cash discount
          sumcashdiscountsumgross  < .optionspaymentsumgross
          sumcashdiscountsumgross.field = sumcashdiscountsumgross
            // Sum net of cash discount
          sumcashdiscountsumnet    < .optionspaymentsumgross
          sumcashdiscountsumnet.field   = sumcashdiscountsumnet

            // Sum gross of items
          sumitemsgross         < .optionspaymentsumgross
          sumitemsgross.field        = sumitemsgross
            // Sum net of items
          sumitemsnet           < .optionspaymentsumgross
          sumitemsnet.field          = sumitemsnet
            // Sum tax normal of items
          sumitemstaxnormal     < .optionspaymentsumgross
          sumitemstaxnormal.field    = sumitemstaxnormal
            // Sum reduced of items
          sumitemstaxreduced    < .optionspaymentsumgross
          sumitemstaxreduced.field   = sumitemstaxreduced

            // Sum gross of payment, shipping and specials
          sumoptionsgross       < .optionspaymentsumgross
          sumoptionsgross.field      = sumoptionsgross
            // Sum net of payment, shipping and specials
          sumoptionsnet         < .optionspaymentsumgross
          sumoptionsnet.field        = sumoptionsnet
            // Sum tax normal of payment, shipping and specials
          sumoptionstaxnormal   < .optionspaymentsumgross
          sumoptionstaxnormal.field  = sumoptionstaxnormal
            // Sum tax reduced of payment, shipping and specials
          sumoptionstaxreduced  < .optionspaymentsumgross
          sumoptionstaxreduced.field = sumoptionstaxreduced

            // Sum gross of options without payment
          sumoptionswopaymentgross       < .optionspaymentsumgross
          sumoptionswopaymentgross.field      = sumoptionswopaymentgross
            // Sum net of options without payment
          sumoptionswopaymentnet         < .optionspaymentsumgross
          sumoptionswopaymentnet.field        = sumoptionswopaymentnet
            // Sum tax normal of options without payment
          sumoptionswopaymenttaxnormal   < .optionspaymentsumgross
          sumoptionswopaymenttaxnormal.field  = sumoptionswopaymenttaxnormal
            // Sum tax reduced of options without payment
          sumoptionswopaymenttaxreduced  < .optionspaymentsumgross
          sumoptionswopaymenttaxreduced.field = sumoptionswopaymenttaxreduced

            // Quantity over all items
          sumsumqty = TEXT
          sumsumqty {
            field = sumsumqty
          }

            // Sum gross over all
          sumsumgross           < .optionspaymentsumgross
          sumsumgross.field          = sumsumgross
            // Sum gross without currency for e-payment
          sumsumgrossepayment = 
          sumsumgrossepayment < plugin.tx_caddy.defaults.numberFormatCurrency
          sumsumgrossepayment {
            field = sumsumgross
            value >
          }
            // Sum net over all
          sumsumnet             < .optionspaymentsumgross
          sumsumnet.field            = sumsumnet
            // Sum tax normal over all
          sumsumtaxnormal       < .optionspaymentsumgross
          sumsumtaxnormal.field      = sumsumtaxnormal
            // Sum tax reduced over all
          sumsumtaxreduced      < .optionspaymentsumgross
          sumsumtaxreduced.field     = sumsumtaxreduced
            // Sum tax over all
          sumsumtaxsum          < .optionspaymentsumgross
          sumsumtaxsum.field         = sumsumtaxsum
          target  = TEXT
          target {
            typolink {
              parameter {
                data = TSFE:id
              }
              returnLast = url
            }
          }
        }
      }
    }
  }
}