  // draft invoice
temp.caddy = 
temp.caddy {
    // default invoice: term of credit, recommend us
  draftInvoice = COA
  draftInvoice {
    wrap = <p>|</p>
      // Line 1: Term of credit
    10 = COA
    10 {
        // Pay
      10 = TEXT
      10 {
        value = Kindly remit the balance
        lang {
          de = Bitte überweisen Sie
          en = Kindly remit the balance
        }
        noTrimWrap = || |
      }
        // amount
      20 = 
      20 < plugin.tx_caddy.defaults.numberFormatCurrency
      20 {
        field = sumsumgross
        value >
        wrap = <b>|</b>
      }
        // until
      21 = TEXT
      21 {
        value = until
        lang {
          de = bis
          en = until
        }
        noTrimWrap = | | |
      }
        // due date
      30 = USER
      30 {
        userFunc = tx_caddy_userfunc->calcDueDate
        userFunc {
          strtotime = {$plugin.caddy.main.dueDate}
          strftime  = {$plugin.caddy.main.dueDateFormat}
        }
      }
        // invoice number
      40 = COA
      40 {
          // text
        10 = TEXT
        10 {
          value = with the annotation
          lang {
            de = mit dem Vermerk
            en = with the annotation
          }
          noTrimWrap  = | | |
        }
          // invoice number
        20 = COA
        20 {
            // label
          10 = TEXT
          10 {
            data = LLL:EXT:caddy/pi1/locallang.xml:invoicenumber
            noTrimWrap = || |
          }
            // prefix
          20 = TEXT
          20 {
            value = {$plugin.caddy.pdf.invoice.number.prefix}
          }
            // number
          30 = TEXT
          30 {
            field = numberInvoiceCurrent
          }
          wrap = "<b>|</b>"
        }
      }
        // to account
      50 = TEXT
      50 {
        value = to our account
        lang {
          de = auf unser Konto
          en = to our account
        }
        noTrimWrap = | |:<br />|
      }
        // IBAN
      60 = COA
      60 {
        10 = TEXT
        10 {
          data = LLL:EXT:caddy/pi1/locallang.xml:IBAN
          noTrimWrap = ||: |
        }
        20 = TEXT
        20 {
          value = {$plugin.caddy.bankaccount.iban}
          lang {
            de = {$plugin.caddy.bankaccount.iban}
            en = {$plugin.caddy.bankaccount.iban}
          }
          noTrimWrap = ||, |
        }
      }
        // BIC
      61 = COA
      61 {
        10 = TEXT
        10 {
          data = LLL:EXT:caddy/pi1/locallang.xml:BIC
          noTrimWrap = ||: |
        }
        20 = TEXT
        20 {
          value = {$plugin.caddy.bankaccount.bic}
          lang {
            de = {$plugin.caddy.bankaccount.bic}
            en = {$plugin.caddy.bankaccount.bic}
          }
          noTrimWrap = ||, |
        }
      }
        // VAT Reg.No.
      62 = COA
      62 {
        10 = TEXT
        10 {
          data = LLL:EXT:caddy/pi1/locallang.xml:tax_reg_no
          noTrimWrap = ||: |
        }
        20 = TEXT
        20 {
          value = {$plugin.caddy.tax.vatregno}
          lang {
            de = {$plugin.caddy.tax.vatregno}
            en = {$plugin.caddy.tax.vatregno}
          }
        }
      }
      wrap  = |<br />
    }
      // Line 2: Recommend us
    20 = TEXT
    20 {
      value = We will be happy, if you recommend us.
      lang {
        de = Wir w&uuml;rden uns freuen, wenn Sie uns weiterempfehlen.
        en = We will be happy, if you recommend us.
      }
    }
  }
}

plugin.tx_caddy_pi1 {
    // empty statement for proper comments only
  _HTMLMARKER {
  }
    // caddy_bankaccount
  _HTMLMARKER =
  _HTMLMARKER {
        // 1. cash in advance. 2. invoice. 3. cash on delivery. 4. cash on pick up. 5. debit note (de: Lastschrift).
    caddy_bankaccount = CASE
    caddy_bankaccount {
        // optionspaymentid
      key = TEXT
      key {
        field = optionspaymentid
      }
        // default error message
      default = COA
      default {
        10 = TEXT
        10 {
          value = TYPOSCRIPT ERROR: key for CASE is undefined. See: plugin.tx_caddy_pi1._HTMLMARKER.caddy_bankaccount. key =
          lang {
            de = TYPOSCRIPT FEHLER: key für CASE ist nicht definiert. Siehe: plugin.tx_caddy_pi1._HTMLMARKER.caddy_bankaccount. key =
            en = TYPOSCRIPT ERROR: key for CASE is undefined. See: plugin.tx_caddy_pi1._HTMLMARKER.caddy_bankaccount. key =
          }
          noTrimWrap = || |
        }
        20 = TEXT
        20 {
          field = optionspaymentid
        }
        wrap = <p>|</p>
      }
        // cash in advance: term of credit, recommend us
        // cash in advance: term of credit, recommend us
      1 = CASE
      1 {
          // plugin.caddy.api.invoice.extra
        key = {$plugin.caddy.api.invoice.note}
          // error prompt
        default = TEXT
        default {
          value = TYPOSCRIPT ERROR: key for CASE is undefined. See: plugin.tx_caddy_pi1._HTMLMARKER.caddy_bankaccount.2.key = {$plugin.caddy.api.invoice.note}
          lang {
            de = TYPOSCRIPT FEHLER: key für CASE ist nicht definiert. Siehe: plugin.tx_caddy_pi1._HTMLMARKER.caddy_bankaccount.2.key = {$plugin.caddy.api.invoice.note}
            en = TYPOSCRIPT ERROR: key for CASE is undefined. See: plugin.tx_caddy_pi1._HTMLMARKER.caddy_bankaccount.2.key = {$plugin.caddy.api.invoice.note}
          }
          wrap = <p>|</p>
        }
          // invoice (de: Rechnung): term of credit, recommend us
        invoice < temp.caddy.draftInvoice
        invoice {
          10 >
          10 = TEXT
          10 {
            value = You have selected the payment method cash in advance. Kindly remit the balance
            lang {
              de = Sie haben als Zahlungsart Vorkasse gewählt: Bitte überweisen Sie
              en = You have selected the payment method cash in advance. Kindly remit the balance
            }
            noTrimWrap = || |
          }
          21 >
          30 >
        }
          // order note: pay cash later
        order = TEXT
        order {
          value = You have selected the payment method cash in advance. Please pay the order after receiving the invoice, which we will send extra.
          lang {
            de = Sie haben als Zahlungsart Vorkasse gewählt: Bitte bezahlen Sie die Bestellung nach Erhalt der Rechnung, die wir Ihnen extra zusenden.
            en = You have selected the payment method cash in advance. Please pay the order after receiving the invoice, which we will send extra.
          }
          wrap = <p>|</p>
        }
      }
        // invoice (de: Rechnung)
      2 = CASE
      2 {
          // plugin.caddy.api.invoice.extra
        key = {$plugin.caddy.api.invoice.note}
          // error prompt
        default = TEXT
        default {
          value = TYPOSCRIPT ERROR: key for CASE is undefined. See: plugin.tx_caddy_pi1._HTMLMARKER.caddy_bankaccount.2.key = {$plugin.caddy.api.invoice.note}
          lang {
            de = TYPOSCRIPT FEHLER: key für CASE ist nicht definiert. Siehe: plugin.tx_caddy_pi1._HTMLMARKER.caddy_bankaccount.2.key = {$plugin.caddy.api.invoice.note}
            en = TYPOSCRIPT ERROR: key for CASE is undefined. See: plugin.tx_caddy_pi1._HTMLMARKER.caddy_bankaccount.2.key = {$plugin.caddy.api.invoice.note}
          }
          wrap = <p>|</p>
        }
          // invoice (de: Rechnung): term of credit, recommend us
        invoice < temp.caddy.draftInvoice
          // order note: pay cash later
        order = TEXT
        order {
          value = Please pay the order after receiving the invoice, which we will send extra.
          lang {
            de = Bitte bezahlen Sie die Bestellung nach Erhalt der Rechnung, die wir Ihnen extra zusenden.
            en = Please pay the order after receiving the invoice, which we will send extra.
          }
          wrap = <p>|</p>
        }
      }
        // cash on delivery (de: Nachnahme): term of credit, recommend us
      3 = TEXT
      3 {
        value = Please pay the cash on delivery.
        lang {
          de = Bitte bezahlen Sie die Ware bei der Lieferung.
          en = Please pay the cash on delivery.
        }
        wrap = <p>|</p>
      }
        // cash on pick up (de: Bar bei Abholung): term of credit, recommend us
      4 = TEXT
      4 {
        value = Please pay the cash on pick up.
        lang {
          de = Bitte bezahlen Sie die Ware bei Abholung.
          en = Please pay the cash on pick up.
        }
        wrap = <p>|</p>
      }
        // debit note (de: Lastschrift): term of credit, recommend us
      5 = TEXT
      5 {
        value = You have selected debit not. Please send us your account data, that we can debit the amount.
        lang {
          de = Sie haben als Zahlungsmethode Lastschrift gewählt. Bitte senden Sie uns Ihre Bankverbindung, damit wir den Betrag von Ihrem Konto abbuchen können.
          en = You have selected debit not. Please send us your account data, that we can debit the amount.
        }
        wrap = <p>|</p>
      }
    }
  }
}